import React from 'react';
import { Modal, ModalHeader, ModalBody } from 'reactstrap';
import DigitalFormBuilderRenderContainer from './digitalFormBuilderRenderContainer';
import DigitalStepperFormRender from './digitalStepperFormRender';
import { useSelector } from 'react-redux';
import { IFormBuilderReducer } from './digitalFormModel';

function DigitalFormBuilderPreview() {

    const digitalFormCreationData: any = useSelector((state: any) => (state.dynamicFormBuilderReducer as IFormBuilderReducer)?.digitalFormCreationData);
    const isModelOpen: boolean = useSelector((state: any) => (state.dynamicFormBuilderReducer as IFormBuilderReducer)?.isDigitalFormPriviewModelOpen);

    return (
        <div>
            <Modal isOpen={isModelOpen} className={`modal-md previewmodal`}>
                <ModalHeader>
                    {digitalFormCreationData?.digitalFormTitle || "Form Priview"}
                </ModalHeader>
                <ModalBody>
                    {!digitalFormCreationData?.digitalFormConfigurations?.isStepperForm && <DigitalFormBuilderRenderContainer digitalFormCreationData={digitalFormCreationData} />}
                    {digitalFormCreationData?.digitalFormConfigurations?.isStepperForm && <DigitalStepperFormRender digitalFormCreationData={digitalFormCreationData} />}
                </ModalBody>
            </Modal>
        </div>
    )
}

export default React.memo(DigitalFormBuilderPreview)
