import React, { useState } from 'react';
import { ElementsTypes } from './digitalFormbuilderElementTypes';
import { v4 as uuidv4 } from 'uuid';
import { useDispatch } from 'react-redux';
import { addDigitalFormControl, addOrEditOrRemoveDigitalFormControlProperties } from '../../store/actions';
import { EOprationalActions } from '../../models/utilitiesModel';


function DigitalFormElementsList() {

    const dispatch = useDispatch();
    const [formElements, setFormElements] = useState(false);

    const handleFormControlAddition = (data) => {
        if (data.isShow) {
            const formData = {
                formControlLabel: '',
                formControlType: data.elemenType,
                formControlProperties: '',
                formControlId: uuidv4(),
                formControlIcon: data.elementIcon
            }
            dispatch(addDigitalFormControl(formData));
            dispatch(addOrEditOrRemoveDigitalFormControlProperties(formData, EOprationalActions.ADD))
        }
    }
    return (
        <div className={'formCreation-left-lft mbfcl-lft ' + (formElements ? 'mb-flex' : 'mb-none')}>
            <div className='mb-back' onClick={() => setFormElements(false)}> &lt;&lt;&nbsp;Back</div>
            <div className="search-box m-3">
                <input type="text" className="form-control" placeholder="Search Element" />
                <i className="icon-search"></i>
            </div>
            <div className='form-elements'>
                {
                    ElementsTypes.map((x, index) => {
                        return <React.Fragment key={index}>
                            <div className='form-elements-sec'>
                                <h6>{x.elementGroupType}</h6>
                                <div className='form-elements-types'>
                                    {
                                        x.elements.map((y, ind) => {
                                            return <React.Fragment key={ind}>
                                                <div onClick={() => { handleFormControlAddition(y) }}>
                                                    <i className={y.elementIcon}></i>
                                                    <small>{y.elemenType}</small>
                                                </div>
                                            </React.Fragment>
                                        })
                                    }
                                </div>
                            </div>
                        </React.Fragment >
                    })
                }
            </div>
        </div>
    )
}

export default React.memo(DigitalFormElementsList)