export interface IFormBuilderReducer {
    formBuilderData: IFormBuilderModel[];
    formDataById: IFormBuilderModel | undefined;
    digitalFormCreationData?: any;
    actionType?: any;
    isDigitalFormConfigModelOpen?: boolean;
    isDigitalFormPriviewModelOpen?: boolean
    actionData: any;
    stepperFormIndex: number
}
export interface IFormBuilderModel {
    formBuilderTitle: string;
    createdOn?: string;
    id: string;
    formBuilderData: IFormBuilderData[];
    formBuilderConfigurations: IFormBuilderConfigurations;
    status?: string;
    formBuilderLinkTable?: IFormBuilderLinkTable[]
}

export interface IFormBuilderLinkTable {
    parentLink: string;
    childLinks: string[]
}

export interface IFormBuilderConfigurations {
    noOfColumns: number;
    isDigitalSave: boolean;
    isStepperForm?: boolean,
    selectedTheme?: string,
    isWebHook?: boolean,
    api?: string,
    apiHeaders?: any;
}

export interface IFormBuilderDateControlConfigurations {
    dateFormat?: string;
    restrictBy?: any;
    noOfDays?: string;
    dateRange?: any;
    fromDate?: string;
    toDate?: string;
}

export enum IFormBuilderDateControlRestrictOptions {
    NO_OF_DAYS = 'noOfDays',
    DATE_RANGE = 'dateRange'
}

export interface IFormBuilderData {
    formControlLabel: string;
    formControlType: string;
    formControlProperties: IFormBuilderControlProperties;
    formControlId?: string;
}

export interface IFormBuilderControlProperties {
    min?: number;
    max?: number;
    pattern?: string;
    isRequired?: boolean;
    requiredMessage?: string;
    defaultValue?: string;
    isTextArea?: boolean;
    optionsData?: IFormBuilderOptionsData[];
    isMulti?: boolean;
    displayType?: string;
    dateFormat?: string;
    isDependencyQuestionRequired?: boolean;
    dependencyCreation?: string | any;
    dependencyMapping?: any;
}


export interface IFormBuilderOptionsData {
    label: string;
    value: string;
    isdefault?: boolean
}

export enum EInputTypes {
    Input = 'input',
    Checkbox = 'checkbox',
    Select = 'select',
    RadioButtons = 'radioButtons',
    Form = 'Form',
    Date = 'Date'
}

export enum EElementInputTypes {
    SINGLELINE = 'Single Line',
    TEXTAREA = 'Text Area',
    NUMBER = 'Number',
    DATE = 'Date',
    DATEANDTIME = `Date & Time`,
    DROPDOWN = 'Dropdown',
    YESORNO = 'Yes/No',
    CHECKBOX = 'Checkbox',
    RADIOBUTTON = 'Radiobutton',
    ATTACHMENTS = 'Attachments',
    IMAGE = 'Image',
    PARAGRAPH = 'Paragraph',
    DIVIDER = 'Divider'
}

export enum EDisplayType {
    Horizontal = 'horizontal',
    Vertical = 'vertical'
}

export enum IFormBuilderDateFormats {
    DD_MM_YYYY = "dd-MM-yyyy",
    YYYY_MM_DD = "yyyy-MM-dd"
}