import React from 'react';
import { EElementInputTypes, IFormBuilderReducer, IFormBuilderData } from './digitalFormModel';
import SingleLinePropertiesComp from './ElementsPropertiesComponents/singleLine';
import DropDownPropertiesComp from './ElementsPropertiesComponents/dropDown';
import CheckboxPropertiesComp from './ElementsPropertiesComponents/checkbox';
import RadioButtonPropertiesComp from './ElementsPropertiesComponents/radioButton';
import DatePropertiesComp from './ElementsPropertiesComponents/date';
import TextAreaPropertiesComp from './ElementsPropertiesComponents/textArea';
import { useSelector } from 'react-redux';

const DigitalFormBuilderControlPropertiesComp: React.FC<any> = () => {

    const actionData: IFormBuilderData = useSelector((state: any) => (state.dynamicFormBuilderReducer as IFormBuilderReducer)?.actionData);

    const isInputControl = actionData?.formControlType === EElementInputTypes.SINGLELINE;
    const isTextAreaControl = actionData?.formControlType === EElementInputTypes.TEXTAREA;
    const isNumberControl = actionData?.formControlType === EElementInputTypes.NUMBER;
    const isSelectControl = actionData?.formControlType === EElementInputTypes.DROPDOWN;
    const isCheckBoxControl = actionData?.formControlType === EElementInputTypes.CHECKBOX;
    const isRadioButtonControl = actionData?.formControlType === EElementInputTypes.RADIOBUTTON;
    const isDateControl = actionData?.formControlType === EElementInputTypes.DATE;

    return (
        <>
            <div className={'formCreation-right mbfc-rgt'}>
                {isInputControl && <SingleLinePropertiesComp />}
                {isSelectControl && <DropDownPropertiesComp />}
                {isCheckBoxControl && <CheckboxPropertiesComp />}
                {isRadioButtonControl && <RadioButtonPropertiesComp />}
                {isDateControl && <DatePropertiesComp />}
                {isTextAreaControl && <TextAreaPropertiesComp />}
                {!actionData && <div className='do-message'>
                    <i className='icon-clarity_settings'></i>
                    <span>Add/Select Elements and Set Properties Here</span>
                </div>}
            </div>
        </>
    )
}

export default React.memo(DigitalFormBuilderControlPropertiesComp)
