import React, { useCallback, useRef, useState } from 'react';
import { Formik } from 'formik';
import { useTranslation } from 'react-i18next';
import * as _ from 'lodash';
import "react-datepicker/dist/react-datepicker.css";
import DigitalFormBuilderRenderContainer from './digitalFormBuilderRenderContainer';




const DigitalStepperFormRender: React.FC<any> = ({ digitalFormCreationData, patchData, cancelCallBack, submitCallBack }) => {
    const { t } = useTranslation("translations");

    const { digitalFormConfigurations, digitalStepperForms, digitalFormTitle } = digitalFormCreationData || {}

    const { initialValues, validationSchema } = digitalStepperForms?.reduce((total, x) => {
        let { initialValues, validationSchema } = total
        return {
            initialValues: {
                ...initialValues,
                [x.stepperFormId]: {
                    stepperFormName: x.stepperFormName,
                    value: patchData ? patchData?.[x.stepperFormId]?.value : ''
                }
            },
            // validationSchema: {
            //     ...validationSchema,
            //     [x.stepperFormId]: Yup.object().shape({
            //         value: Yup.mixed().required()
            //     })
            // }
        }
    }, { initialValues: { stepperIndex: 0 }, validationSchema: {} });

    console.log('stepperFormInitialValues=>', { validationSchema, initialValues })

    return (
        <div>
            <Formik
                enableReinitialize
                initialValues={initialValues}
                validationSchema={validationSchema}
                onSubmit={values => {
                    console.log('parentStepperData==>', values);
                    const { stepperIndex, ...rest } = values;
                    if (submitCallBack)
                        submitCallBack(rest);
                    else
                        alert(JSON.stringify(rest, undefined, 5));
                    // alert(JSON.stringify(rest, null, 6))
                }}
            >
                {
                    ({ values, setFieldValue, handleSubmit }) => (
                        <>
                            <DigitalFormBuilderRenderContainer
                                digitalFormCreationData={digitalFormCreationData}
                                stepperIndex={values.stepperIndex}
                                parentSetFieldValue={setFieldValue}
                                parentValues={values}
                                parentSubmitForm={handleSubmit}
                                cancelCallBack={cancelCallBack}
                            />
                        </>
                    )
                }
            </Formik>
        </div>
    );
};

export default React.memo(DigitalStepperFormRender);